/* makeGridConnect.cc
--------------------------------------------------------
 gcnd ˤ륰åɴ֤³ե
 makeSubConnect ˤüֹ桦üֹбɽ
 Ȥ顢üֹ𤷤ϴ֤³ե
 ץ
--------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
  if (argc != 1 && argc != 4) {
    printf("Usage : makeGridConnect gcnd-connectFile ");
    printf("EpPrtTable outputFile\n");
    exit(1);
  }

  char gcnd[256], table[256], connect[256];

  if (argc == 1) {
    printf("# gcnd connect file name : ");
    scanf("%s", gcnd);
    printf("# epNum-portNum table file name : ");
    scanf("%s", table);
    printf("# output file name : ");
    scanf("%s", connect);
  }

  else {
    sscanf(argv[1], "%s", gcnd);
    sscanf(argv[2], "%s", table);
    sscanf(argv[3], "%s", connect);
  }

  FILE* fp_gcnd;
  FILE* fp_table;
  FILE* fp_connect;

  char buf[256], buf2[256];
  char HEAD[256];            // ƬˤĤĥ
  int s_len = strlen(gcnd);
  for (int i = 0; i < s_len; i++) {
    if (gcnd[i] != '-') HEAD[i] = gcnd[i];
    else {
      HEAD[i] = gcnd[i];
      break;
    }
  }

  int d_x, d_y, d_epNo, u_x, u_y, u_epNo;
  char D_X[10], D_Y[10], D_No[10], U_X[10], U_Y[10], U_No[10];
  char d_obname[256], u_obname[256];

  int d_flag = 0, u_flag = 0;
  int x, y, sysNo, epNo, prtNo;

  int d_prtNo, u_prtNo;


  if((fp_gcnd = fopen(gcnd, "r")) == NULL){
    printf("Cannot open grid-connect dat from 'gcnd'.\n");
    exit(1);
  }

  fp_connect = fopen(connect, "w");


  int line_in = 0;
  int line_out = 0;
  int dummy1, dummy2;


  while(fgets(buf, 256, fp_gcnd) != NULL){

    // ȹԡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;

    else{
      if(sscanf(buf, "%d %d %d %d %d %d %d %d", &d_x, &d_y,
				&d_epNo, &dummy1, &u_x, &u_y, &u_epNo, &dummy2) != 8){
		  printf("Cannot scan data.\n");
		  exit(1);
      }	

//      printf("%d %d %d %d %d %d\n", d_x, d_y, d_epNo,
//	     u_x, u_y, u_epNo);

      line_in++;

      if((fp_table = fopen(table, "r")) == NULL){
    	printf("Cannot open table file.\n");
	    exit(1);
      }

      while(fgets(buf2, 256, fp_table) != NULL){

	// ȹԡԤν
	    if((buf2[0] == '#') || (buf2[0] == '\n')) continue;

	    else{
	      if(sscanf(buf2, "%d %d %d %d %d", &x, &y, &sysNo, &epNo, &prtNo)
	         != 5){
	        printf("Cannot scan data from table.\n");
	        exit(1);
	      }
//	  printf("%d %d %d %d %d\n", x, y, sysNo, epNo, prtNo);

	      if((x == d_x) && (y == d_y) && (epNo == d_epNo)){
	        sprintf(D_X, "%d", x);
	        sprintf(D_Y, "%d", y);
	        sprintf(D_No, "%d", sysNo);
	        strcpy(d_obname, HEAD);
	        strcat(d_obname, D_X);
	        strcat(d_obname, "-");
	        strcat(d_obname, D_Y);
	        strcat(d_obname, "-");
	        strcat(d_obname, D_No);

			printf("Down %d %s\n",line_in, d_obname);
	        d_prtNo = prtNo;
	    
	        d_flag = 1;
	      }

	      else if((x == u_x) && (y == u_y) && (epNo == u_epNo)){
	        sprintf(U_X, "%d", x);
	        sprintf(U_Y, "%d", y);
	        sprintf(U_No, "%d", sysNo);
	        strcpy(u_obname, HEAD);
	        strcat(u_obname, U_X);
	        strcat(u_obname, "-");
	        strcat(u_obname, U_Y);
	        strcat(u_obname, "-");
	        strcat(u_obname, U_No);

			printf("Up %d %s\n", line_in, u_obname);

	        u_prtNo = prtNo;

	        u_flag = 1;
	     }

	     if((d_flag == 1) && (u_flag == 1)){
	        fprintf(fp_connect, "%s %d %s %d\n",
		        d_obname, d_prtNo, u_obname, u_prtNo);
	         d_flag = 0;
	         u_flag = 0;
	         line_out++;
	         break;
	     }
	   }
      }

      fclose(fp_table);
    }
  }

  fclose(fp_gcnd);
  fclose(fp_connect);

  if(line_in != line_out){
    printf("There are wrong data in Input Files.\n");
	printf("in %d, out %d\n", line_in, line_out);
	exit(1);
  }

  return 0;
}
